<?php
class ControllerPaymentinvoicebox extends Controller {
	private $error = array(); 

	public function index() {
		$this->language->load('payment/invoicebox');

		$this->document->setTitle($this->language->get('heading_title'));
		
		$this->load->model('setting/setting');
			
		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('invoicebox', $this->request->post);				
			
			$this->session->data['success'] = $this->language->get('text_success');

			$this->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$this->data['heading_title'] = $this->language->get('heading_title');

		$this->data['text_enabled'] = $this->language->get('text_enabled');
		$this->data['text_disabled'] = $this->language->get('text_disabled');
		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		
		$this->data['entry_participant_id'] = $this->language->get('entry_participant_id');
		$this->data['entry_participant_key'] = $this->language->get('entry_participant_key');
		$this->data['entry_participant_apikey'] = $this->language->get('entry_participant_apikey');
		$this->data['entry_callback'] = $this->language->get('entry_callback');
		$this->data['entry_total'] = $this->language->get('entry_total');	
		$this->data['entry_order_status'] = $this->language->get('entry_order_status');		
		$this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
		$this->data['entry_status'] = $this->language->get('entry_status');
		$this->data['entry_sort_order'] = $this->language->get('entry_sort_order');

		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');

  		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}

 		if (isset($this->error['participant_id'])) {
			$this->data['error_participant_id'] = $this->error['participant_id'];
		} else {
			$this->data['error_participant_id'] = '';
		}

 		if (isset($this->error['participant_key'])) {
			$this->data['error_participant_key'] = $this->error['participant_key'];
		} else {
			$this->data['error_participant_key'] = '';
		}

 		if (isset($this->error['participant_apikey'])) {
			$this->data['error_participant_apikey'] = $this->error['participant_apikey'];
		} else {
			$this->data['error_participant_apikey'] = '';
		}
		
  		$this->data['breadcrumbs'] = array();

   		$this->data['breadcrumbs'][] = array(
       			'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
      			'separator' => false
   		);

   		$this->data['breadcrumbs'][] = array(
       			'text'      => $this->language->get('text_payment'),
			'href'      => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'),
      			'separator' => ' :: '
   		);

   		$this->data['breadcrumbs'][] = array(
       			'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('payment/invoicebox', 'token=' . $this->session->data['token'], 'SSL'),
      			'separator' => ' :: '
   		);
				
		$this->data['action'] = $this->url->link('payment/invoicebox', 'token=' . $this->session->data['token'], 'SSL');
		
		$this->data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');
		
		if (isset($this->request->post['invoicebox_participant_id'])) {
			$this->data['invoicebox_participant_id'] = $this->request->post['invoicebox_participant_id'];
		} else {
			$this->data['invoicebox_participant_id'] = $this->config->get('invoicebox_participant_id');
		}

		if (isset($this->request->post['invoicebox_participant_key'])) {
			$this->data['invoicebox_participant_key'] = $this->request->post['payinvoicebox_participant_key'];
		} else {
			$this->data['invoicebox_participant_key'] = $this->config->get('invoicebox_participant_key');
		}

		if (isset($this->request->post['invoicebox_participant_apikey'])) {
			$this->data['invoicebox_participant_apikey'] = $this->request->post['payinvoicebox_participant_apikey'];
		} else {
			$this->data['invoicebox_participant_apikey'] = $this->config->get('invoicebox_participant_apikey');
		}
		
		$this->data['callback'] = HTTP_CATALOG . 'index.php?route=payment/invoicebox/callback';
		
		if (isset($this->request->post['invoicebox_total'])) {
			$this->data['invoicebox_total'] = $this->request->post['invoicebox_total'];
		} else {
			$this->data['invoicebox_total'] = $this->config->get('invoicebox_total'); 
		} 
				
		if (isset($this->request->post['invoicebox_order_status_id'])) {
			$this->data['invoicebox_order_status_id'] = $this->request->post['invoicebox_order_status_id'];
		} else {
			$this->data['invoicebox_order_status_id'] = $this->config->get('invoicebox_order_status_id'); 
		} 
		
		$this->load->model('localisation/order_status');
		
		$this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		
		if (isset($this->request->post['invoicebox_geo_zone_id'])) {
			$this->data['invoicebox_geo_zone_id'] = $this->request->post['invoicebox_geo_zone_id'];
		} else {
			$this->data['invoicebox_geo_zone_id'] = $this->config->get('invoicebox_geo_zone_id'); 
		} 

		$this->load->model('localisation/geo_zone');
										
		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
		
		if (isset($this->request->post['invoicebox_status'])) {
			$this->data['invoicebox_status'] = $this->request->post['invoicebox_status'];
		} else {
			$this->data['invoicebox_status'] = $this->config->get('invoicebox_status');
		}
		
		if (isset($this->request->post['invoicebox_sort_order'])) {
			$this->data['invoicebox_sort_order'] = $this->request->post['invoicebox_sort_order'];
		} else {
			$this->data['invoicebox_sort_order'] = $this->config->get('invoicebox_sort_order');
		}

		$this->template = 'payment/invoicebox.tpl';
		$this->children = array(
			'common/header',
			'common/footer'
		);
				
		$this->response->setOutput($this->render());
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'payment/invoicebox')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}
		
		if (!$this->request->post['invoicebox_participant_id']) {
			$this->error['participant_id'] = $this->language->get('error_participant_id');
		}

		if (!$this->request->post['invoicebox_participant_key']) {
			$this->error['participant_key'] = $this->language->get('error_participant_key');
		}

		if (!$this->request->post['invoicebox_participant_apikey']) {
			$this->error['participant_apikey'] = $this->language->get('error_participant_apikey');
		}
		
		if (!$this->error) {
			return true;
		} else {
			return false;
		}	
	}
}
?>