<?php
class ControllerPaymentinvoicebox extends Controller {
	protected function index() {
		$this->data['button_confirm'] = $this->language->get('button_confirm');

		$this->load->model('checkout/order');
		
		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
		
		$this->data['action'] = 'https://go.invoicebox.ru/module_ibox_auto.u';

		$this->data['itransfer_participant_id'] 	= $this->config->get('invoicebox_participant_id');
		$this->data['itransfer_order_amount'] 		= $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);
		$this->data['itransfer_order_currency_ident'] 	= $order_info['currency_code'];
		$this->data['itransfer_order_description'] 	= $this->config->get('config_name') . ' - #' . $this->session->data['order_id'];
		$this->data['itransfer_order_id']		= $this->session->data['order_id'];
		$this->data['itransfer_person_name']		= $order_info['payment_firstname'] . " " . $order_info['payment_lastname'];
		$this->data['itransfer_person_email']		= $order_info['email'];
		$this->data['itransfer_person_phone']		= $order_info['telephone'];
		$this->data['itransfer_url_return']		= $this->url->link('checkout/success');
		$this->data['itransfer_url_cancel']		= $this->url->link('checkout/checkout', '', 'SSL');
		$this->data['itransfer_scheme_id']		= 'DEFAULT';

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/invoicebox.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/invoicebox.tpl';
		} else {
			$this->template = 'default/template/payment/invoicebox.tpl';
		}		
		
		$this->render();
	}
	
	public function callback()
	{
		$sign = isset($this->request->post['sign']) ? $this->request->post['sign'] : "";
		if ( !$sign ) die( "No sign" );

		$participantId = isset($this->request->post['participantId']) ? $this->request->post['participantId'] : "";
		$participantOrderId = isset($this->request->post['participantOrderId']) ? $this->request->post['participantOrderId'] : "";
		$ucode = isset($this->request->post['ucode']) ? $this->request->post['ucode'] : "";
		$timetype = isset($this->request->post['timetype']) ? $this->request->post['timetype'] : "";
		$time = isset($this->request->post['time']) ? $this->request->post['time'] : "";
		$amount = isset($this->request->post['amount']) ? $this->request->post['amount'] : "";
		$agentName = isset($this->request->post['agentName']) ? $this->request->post['agentName'] : "";
		$agentPointName = isset($this->request->post['agentPointName']) ? $this->request->post['agentPointName'] : "";

		$testsign = md5(
			$participantId . 
			$participantOrderId .
			$ucode .
			$timetype .
			$time .
			$amount .
			$agentName .
			$agentPointName .
			$this->config->get('invoicebox_participant_apikey')
		); //

		if ( $sign != $testsign ) die( "Incorrect sign" );

		$this->load->model('checkout/order');
		$this->model_checkout_order->confirm( $participantOrderId, $this->config->get('invoicebox_order_status_id'));
		die( "OK" );
	}
}
?>